package com.muyu.config;

import com.alibaba.druid.pool.DruidDataSource;


import com.muyu.config.holder.DynamicDataSourceHolder;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.jdbc.datasource.lookup.AbstractRoutingDataSource;

import java.util.Map;

/** 动态数据源调用
 * @ClassDescription:
 * @JdkVersion: 17
 * @Author: zhangxu
 * @Created: 2024/6/4 8:54
 */

@Data
@AllArgsConstructor
@NoArgsConstructor
public class DynamicDataSource extends AbstractRoutingDataSource {


    /***
     *
     * 备份所有的数据源信息 备份的是个指针
     *
     * **/
    private Map<Object, Object> defineTargetDataSources;



    public void put(String key, DruidDataSource value){
    defineTargetDataSources.put(key,value);
    }


    /**
     *
     * 决定当前线程使用那个数据源
     * **/
   @Override
   protected Object determineCurrentLookupKey() {
        return DynamicDataSourceHolder.getDynamicDatasourceKey();
    }



}
