package com.muyu.config.factory;

import com.alibaba.druid.pool.DruidDataSource;
import com.muyu.config.domain.model.DataSourceInfo;
import lombok.extern.log4j.Log4j2;
import org.springframework.stereotype.Component;

import java.sql.SQLException;

/** 工厂
 * @ClassDescription:
 * @JdkVersion: 17
 * @Author: zhangxu
 * @Created: 2024/6/4 9:09
 */
@Log4j2
@Component
public class DruidDataSourceFactory {


    public DruidDataSource create(DataSourceInfo dataSourceInfo){
        DruidDataSource druidDataSource = new DruidDataSource();
        druidDataSource.setUrl(dataSourceInfo.getUrl());
        druidDataSource.setUsername(dataSourceInfo.getUserName());
        druidDataSource.setPassword(dataSourceInfo.getPassword());
        druidDataSource.setBreakAfterAcquireFailure(true);
        druidDataSource.setConnectionErrorRetryAttempts(0);
        try {
            druidDataSource.getConnection(2000);
            log.info("连接成功");
            return druidDataSource;
        } catch (SQLException e) {
            log.error("连接失败");
            return null;
        }
    }


}
