package com.muyu.config.holder;

import lombok.extern.log4j.Log4j2;
import lombok.extern.slf4j.Slf4j;
import org.springframework.util.Assert;

/**
 * @ClassDescription:
 * @JdkVersion: 17
 * @Author: zhangxu
 * @Created: 2024/6/4 14:11
 */
@Slf4j
public class DynamicDataSourceHolder {

    private static final ThreadLocal<String> DYNAMIC_DATASOURCE = new ThreadLocal<>();

    public static void setDynamicDatasourceKey(String key) {
        log.info("数据源切换为:{}", key);
        DYNAMIC_DATASOURCE.set(key);
    }

    public static String getDynamicDatasourceKey() {
        String key = DYNAMIC_DATASOURCE.get();
        Assert.notNull(key,"请携带数据表示");
        return key;
    }

    public static void removeDynamicDatasourceKey() {
        log.info("移除数据源：{}", DYNAMIC_DATASOURCE.get());
        DYNAMIC_DATASOURCE.remove();
    }


}
